Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3876)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3883)
@@ -3778,30 +3813,25 @@
 !--      because the nest domain is not cyclic.
 !--      From south to north
-         CALL MPI_SENDRECV( workarrc_lr(0,jcsw+1,0), 1,                         &
-              workarrc_lr_exchange_type, psouth,  0,                            &
-              workarrc_lr(0,jcnw,0), 1,                                         &
-              workarrc_lr_exchange_type, pnorth,  0,                            &
-              comm2d, status, ierr )                                      
-!                                                                         
-!--      From north to south                                              
-         CALL MPI_SENDRECV( workarrc_lr(0,jcnw-1,0), 1,                         &
-              workarrc_lr_exchange_type, pnorth,  1,                            &
-              workarrc_lr(0,jcsw,0), 1,                                         &
-              workarrc_lr_exchange_type, psouth,  1,                            &
-              comm2d, status, ierr )                                      
-#endif                                                                    
-      ELSE                                                                
-         workarrc_lr(0:cg%nz+1,jcsw:jcnw,0:2)                                   &
-              = fc(0:cg%nz+1,jcsw:jcnw,lbeg:lbeg+2)            
+         CALL MPI_SENDRECV( workarr_lr(0,jpsw+1,0), 1, workarr_lr_exchange_type, psouth,  0,        &
+                            workarr_lr(0,jpnw,0), 1, workarr_lr_exchange_type, pnorth,  0, comm2d,  &
+                            status, ierr )                              
+!                                                                             
+!--      From north to south                                                  
+         CALL MPI_SENDRECV( workarr_lr(0,jpnw-1,0), 1, workarr_lr_exchange_type, pnorth,  1,        &
+                            workarr_lr(0,jpsw,0), 1, workarr_lr_exchange_type, psouth,  1, comm2d,  &
+                            status, ierr )                               
+#endif                                                                        
+      ELSE                                                                    
+         workarr_lr(0:pg%nz+1,jpsw:jpnw,0:2) = parent_array(0:pg%nz+1,jpsw:jpnw,ipbeg:ipbeg+2)            
       ENDIF
 
-      IF  ( var == 'u' )  THEN
-
-         DO  m = jcsw, jcnw
-            DO n = 0, kct 
+      IF ( var == 'u' )  THEN
+
+         DO  jp = jpsw, jpnw
+            DO  kp = 0, kct 
                
-               DO  j = jfl(m), jfu(m)
-                  DO  k = kfl(n), kfu(n)
-                     f(k,j,ibc) = workarrc_lr(n,m,lw)
+               DO  jc = jfl(jp), jfu(jp)
+                  DO  kc = kfl(kp), kfu(kp)
+                     child_array(kc,jc,icbc) = workarr_lr(kp,jp,ipw)
                   ENDDO
                ENDDO
@@ -3810,21 +3840,21 @@
          ENDDO
 
-      ELSE IF  ( var == 'v' )  THEN
+      ELSE IF ( var == 'v' )  THEN
          
-         DO  m = jcsw, jcnw-1
-            DO n = 0, kct 
+         DO  jp = jpsw, jpnw-1
+            DO  kp = 0, kct 
 !
 !--            First interpolate to the flux point
-               f_interp_1 = cb * workarrc_lr(n,m,lw)   + cp * workarrc_lr(n,m,lwp)
-               f_interp_2 = cb * workarrc_lr(n,m+1,lw) + cp * workarrc_lr(n,m+1,lwp)
+               c_interp_1 = cb * workarr_lr(kp,jp,ipw)   + cp * workarr_lr(kp,jp,ipwp)
+               c_interp_2 = cb * workarr_lr(kp,jp+1,ipw) + cp * workarr_lr(kp,jp+1,ipwp)
 !
 !--            Use averages of the neighbouring matching grid-line values
-               DO  j = jfl(m), jfl(m+1)
-                  f(kfl(n):kfu(n),j,ibc) = 0.5_wp * ( f_interp_1 + f_interp_2 )
+               DO  jc = jfl(jp), jfl(jp+1)
+                  child_array(kfl(kp):kfu(kp),jc,icbc) = 0.5_wp * ( c_interp_1 + c_interp_2 )
                ENDDO
 !
 !--            Then set the values along the matching grid-lines  
-               IF  ( MOD( jfl(m), jgsr ) == 0 )  THEN
-                  f(kfl(n):kfu(n),jfl(m),ibc) = f_interp_1
+               IF  ( MOD( jfl(jp), jgsr ) == 0 )  THEN
+                  child_array(kfl(kp):kfu(kp),jfl(jp),icbc) = c_interp_1
                ENDIF
             ENDDO
@@ -3832,8 +3862,8 @@
 !
 !--      Finally, set the values along the last matching grid-line  
-         IF  ( MOD( jfl(jcnw), jgsr ) == 0 )  THEN
-            DO  n = 0, kct
-               f_interp_1 = cb * workarrc_lr(n,jcnw,lw) + cp * workarrc_lr(n,jcnw,lwp)
-               f(kfl(n):kfu(n),jfl(jcnw),ibc) = f_interp_1
+         IF ( MOD( jfl(jpnw), jgsr ) == 0 )  THEN
+            DO  kp = 0, kct
+               c_interp_1 = cb * workarr_lr(kp,jpnw,ipw) + cp * workarr_lr(kp,jpnw,ipwp)
+               child_array(kfl(kp):kfu(kp),jfl(jpnw),icbc) = c_interp_1
             ENDDO
          ENDIF
@@ -3843,33 +3873,34 @@
 !--      gap. Note however, this operation may produce some additional 
 !--      momentum conservation error.
-         IF  ( jfl(jcnw) < nyn )  THEN
-            DO  n = 0, kct
-               DO  j = jfl(jcnw)+1, nyn
-                  f(kfl(n):kfu(n),j,ibc) = f(kfl(n):kfu(n),jfl(jcnw),ibc)
+         IF ( jfl(jpnw) < nyn )  THEN
+            DO  kp = 0, kct
+               DO  jc = jfl(jpnw) + 1, nyn
+                  child_array(kfl(kp):kfu(kp),jc,icbc) = child_array(kfl(kp):kfu(kp),jfl(jpnw),icbc)
                ENDDO
             ENDDO
          ENDIF
 
-      ELSE IF  ( var == 'w' )  THEN
-
-         DO  m = jcsw, jcnw
-            DO n = 0, kct + 1   ! It is important to go up to kct+1  
+      ELSE IF ( var == 'w' )  THEN
+
+         DO  jp = jpsw, jpnw
+            DO  kp = 0, kct + 1   ! It is important to go up to kct+1  
 !
 !--            Interpolate to the flux point
-               f_interp_1 = cb * workarrc_lr(n,m,lw) + cp * workarrc_lr(n,m,lwp)
+               c_interp_1 = cb * workarr_lr(kp,jp,ipw) + cp * workarr_lr(kp,jp,ipwp)
 !
 !--            First substitute only the matching-node values
-               f(kfu(n),jfl(m):jfu(m),ibc) = f_interp_1
+               child_array(kfu(kp),jfl(jp):jfu(jp),icbc) = c_interp_1
                   
             ENDDO
          ENDDO
 
-         DO  m = jcsw, jcnw
-            DO n = 1, kct + 1   ! It is important to go up to kct+1  
+         DO  jp = jpsw, jpnw
+            DO  kp = 1, kct + 1   ! It is important to go up to kct+1  
 !
 !--            Then fill up the nodes in between with the averages                  
-               DO  k = kfu(n-1)+1, kfu(n)-1 
-                  f(k,jfl(m):jfu(m),ibc) = 0.5_wp * ( f(kfu(n-1),jfl(m):jfu(m),ibc) &
-                       + f(kfu(n),jfl(m):jfu(m),ibc) )
+               DO  kc = kfu(kp-1) + 1, kfu(kp) - 1 
+                  child_array(kc,jfl(jp):jfu(jp),icbc) =                                            &
+                       0.5_wp * ( child_array(kfu(kp-1),jfl(jp):jfu(jp),icbc)                       &
+                       + child_array(kfu(kp),jfl(jp):jfu(jp),icbc) )
                ENDDO
                   
@@ -3879,12 +3910,12 @@
       ELSE   ! any scalar
          
-         DO  m = jcsw, jcnw
-            DO n = 0, kct 
+         DO  jp = jpsw, jpnw
+            DO  kp = 0, kct 
 !
 !--            Interpolate to the flux point
-               f_interp_1 = cb * workarrc_lr(n,m,lw) + cp * workarrc_lr(n,m,lwp)
-               DO  j = jfl(m), jfu(m)
-                  DO  k = kfl(n), kfu(n)
-                     f(k,j,ibc) = f_interp_1
+               c_interp_1 = cb * workarr_lr(kp,jp,ipw) + cp * workarr_lr(kp,jp,ipwp)
+               DO  jc = jfl(jp), jfu(jp)
+                  DO  kc = kfl(kp), kfu(kp)
+                     child_array(kc,jc,icbc) = c_interp_1
                   ENDDO
                ENDDO
@@ -3897,10 +3928,10 @@
 !--   Fill up also the redundant 2nd and 3rd ghost-node layers
       IF ( edge == 'l' )  THEN
-         DO  ibgp = -nbgp, ib
-            f(0:nzt+1,nysg:nyng,ibgp) = f(0:nzt+1,nysg:nyng,ibc)
+         DO  icbgp = -nbgp, icb
+            child_array(0:nzt+1,nysg:nyng,icbgp) = child_array(0:nzt+1,nysg:nyng,icbc)
          ENDDO
       ELSEIF ( edge == 'r' )  THEN
-         DO  ibgp = ib, nx+nbgp
-            f(0:nzt+1,nysg:nyng,ibgp) = f(0:nzt+1,nysg:nyng,ibc)
+         DO  icbgp = icb, nx+nbgp
+            child_array(0:nzt+1,nysg:nyng,icbgp) = child_array(0:nzt+1,nysg:nyng,icbc)
          ENDDO
       ENDIF
@@ -3910,5 +3941,5 @@
 
 
-   SUBROUTINE pmci_interp_1sto_sn( f, fc, kct, ifl, ifu, kfl, kfu, edge, var )
+   SUBROUTINE pmci_interp_1sto_sn( child_array, parent_array, kct, ifl, ifu, kfl, kfu, edge, var )
 !
 !--   Interpolation of ghost-node values used as the child-domain boundary
@@ -3916,31 +3947,42 @@
       IMPLICIT NONE
 
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  f   !< Child-grid array
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN)        ::  fc  !< Parent-grid array
-      INTEGER(iwp) :: kct                                     !< The parent-grid index in z-direction just below the boundary value node
-      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifl  !< Indicates start index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(icla:icra), INTENT(IN) ::  ifu  !< Indicates end index of child cells belonging to certain parent cell - x direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfl  !< Indicates start index of child cells belonging to certain parent cell - z direction
-      INTEGER(iwp), DIMENSION(0:cg%nz+1), INTENT(IN) ::  kfu  !< Indicates end index of child cells belonging to certain parent cell - z direction
+      INTEGER(iwp), INTENT(IN) ::  kct  !< The parent-grid index in z-direction just below the boundary value node
+      
+      INTEGER(iwp), DIMENSION(ipla:ipra), INTENT(IN) ::  ifl  !< Indicates start index of child cells belonging to certain
+                                                              !< parent cell - x direction
+      INTEGER(iwp), DIMENSION(ipla:ipra), INTENT(IN) ::  ifu  !< Indicates end index of child cells belonging to certain
+                                                              !< parent cell - x direction
+      INTEGER(iwp), DIMENSION(0:pg%nz+1), INTENT(IN) ::  kfl  !< Indicates start index of child cells belonging to certain
+                                                              !< parent cell - z direction
+      INTEGER(iwp), DIMENSION(0:pg%nz+1), INTENT(IN) ::  kfu  !< Indicates end index of child cells belonging to certain
+                                                              !< parent cell - z direction
+      
+      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  child_array   !< Child-grid array
+      REAL(wp), DIMENSION(0:pg%nz+1,jps:jpn,ipl:ipr), INTENT(IN)        ::  parent_array  !< Parent-grid array
+
       CHARACTER(LEN=1), INTENT(IN) ::  edge   !< Edge symbol: 's' or 'n' 
       CHARACTER(LEN=1), INTENT(IN) ::  var    !< Variable symbol: 'u', 'v', 'w' or 's'
 !
 !--   Local variables:      
-      INTEGER(iwp) ::  i        !< Running index in the x-direction
+      INTEGER(iwp) ::  ic       !< Running child-grid index in the x-direction
       INTEGER(iwp) ::  ierr     !< MPI error code
-      INTEGER(iwp) ::  jb       !< Fixed j-index pointing to the node just behind the boundary-value node
-      INTEGER(iwp) ::  jbc      !< Fixed j-index pointing to the boundary-value nodes (either j or jend)
-      INTEGER(iwp) ::  jbgp     !< Index running over the redundant boundary ghost points in j-direction
-      INTEGER(iwp) ::  k        !< Running index in the z-direction
-      INTEGER(iwp) ::  l        !< Parent-grid running index in the x-direction
-      INTEGER(iwp) ::  mbeg     !< m-index pointing to the starting point of workarrc_sn in the m-direction 
-      INTEGER(iwp) ::  mw       !< Reduced m-index for workarrc_sn pointing to the boundary ghost node 
-      INTEGER(iwp) ::  mwp      !< Reduced m-index for workarrc_sn pointing to the first prognostic node
-      INTEGER(iwp) ::  n        !< Parent-grid running index in the z-direction
+      INTEGER(iwp) ::  ip       !< Running parent-grid index in the x-direction
+      INTEGER(iwp) ::  jcb      !< Fixed child-grid index in the y-direction pointing to the node just behind the
+                                !< boundary-value node
+      INTEGER(iwp) ::  jcbc     !< Fixed child-grid index in the y-direction pointing to the boundary-value nodes
+      INTEGER(iwp) ::  jcbgp    !< Index running over the redundant boundary ghost points in y-direction
+      INTEGER(iwp) ::  kc       !< Running child-grid index in the z-direction      
+      INTEGER(iwp) ::  kp       !< Running parent-grid index in the z-direction
+      INTEGER(iwp) ::  jpbeg    !< Parent-grid index in the y-direction pointing to the starting point of workarr_sn
+                                !< in the parent-grid array
+      INTEGER(iwp) ::  jpw      !< Reduced parent-grid index in the y-direction for workarr_sn pointing to
+                                !< the boundary ghost node 
+      INTEGER(iwp) ::  jpwp     !< Reduced parent-grid index in the y-direction for workarr_sn pointing to
+                                !< the first prognostic node
       REAL(wp) ::  cb           !< Interpolation coefficient for the boundary ghost node  
       REAL(wp) ::  cp           !< Interpolation coefficient for the first prognostic node
-      REAL(wp) ::  f_interp_1   !< Value interpolated in y direction from the parent-grid data
-      REAL(wp) ::  f_interp_2   !< Auxiliary value interpolated in y direction from the parent-grid data
-
+      REAL(wp) ::  c_interp_1   !< Value interpolated to the flux point in x direction from the parent-grid data
+      REAL(wp) ::  c_interp_2   !< Auxiliary value interpolated  to the flux point in x direction from the parent-grid data
+      
 !
 !--   Check which edge is to be handled: south or north
@@ -3949,55 +3991,53 @@
 !--      For v, nys is a ghost node, but not for the other variables
          IF ( var == 'v' )  THEN
-            jbc   = nys
-            jb    = jbc - 1
-            mw    = 2
-            mwp   = 2         ! This is redundant when var == 'v'
-            mbeg  = jcs
+            jcbc  = nys
+            jcb   = jcbc - 1
+            jpw   = 2
+            jpwp  = 2         ! This is redundant when var == 'v'
+            jpbeg = jps
          ELSE
-            jbc   = nys - 1
-            jb    = jbc - 1
-            mw    = 1
-            mwp   = 2
-            mbeg  = jcs
+            jcbc  = nys - 1
+            jcb   = jcbc - 1
+            jpw   = 1
+            jpwp  = 2
+            jpbeg = jps
          ENDIF
       ELSEIF ( edge == 'n' )  THEN
          IF ( var == 'v' )  THEN
-            jbc   = nyn + 1
-            jb    = jbc + 1
-            mw    = 1
-            mwp   = 0         ! This is redundant when var == 'v'     
-            mbeg  = jcn - 2
+            jcbc  = nyn + 1
+            jcb   = jcbc + 1
+            jpw   = 1
+            jpwp  = 0         ! This is redundant when var == 'v'     
+            jpbeg = jpn - 2
          ELSE
-            jbc   = nyn + 1
-            jb    = jbc + 1
-            mw    = 1
-            mwp   = 0
-            mbeg  = jcn - 2
+            jcbc  = nyn + 1
+            jcb   = jcbc + 1
+            jpw   = 1
+            jpwp  = 0
+            jpbeg = jpn - 2
          ENDIF
       ENDIF
 !
 !--   Interpolation coefficients
-      IF  ( interpolation_scheme_lrsn == 1 )  THEN
+      IF ( interpolation_scheme_lrsn == 1 )  THEN
          cb = 1.0_wp  ! 1st-order upwind 
-      ELSE IF  ( interpolation_scheme_lrsn == 2 )  THEN
+      ELSE IF ( interpolation_scheme_lrsn == 2 )  THEN
          cb = 0.5_wp  ! 2nd-order central
       ELSE
          cb = 0.5_wp  ! 2nd-order central (default)
       ENDIF         
-      cp    = 1.0_wp - cb
-!
-!--   Substitute the necessary parent-grid data to the work array workarrc_sn. 
-      workarrc_sn = 0.0_wp     
-      IF  ( pdims(1) > 1 )  THEN
+      cp = 1.0_wp - cb
+!
+!--   Substitute the necessary parent-grid data to the work array workarr_sn. 
+      workarr_sn = 0.0_wp     
+      IF ( pdims(1) > 1 )  THEN
 #if defined( __parallel )
-         IF  ( bc_dirichlet_l )  THEN
-            workarrc_sn(0:cg%nz+1,0:2,iclw:icrw-1)                              &
-                 = fc(0:cg%nz+1,mbeg:mbeg+2,iclw:icrw-1)
-         ELSE IF  ( bc_dirichlet_r )  THEN
-            workarrc_sn(0:cg%nz+1,0:2,iclw+1:icrw)                              &
-                 = fc(0:cg%nz+1,mbeg:mbeg+2,iclw+1:icrw)
+         IF ( bc_dirichlet_l )  THEN
+            workarr_sn(0:pg%nz+1,0:2,iplw:iprw-1) = parent_array(0:pg%nz+1,jpbeg:jpbeg+2,iplw:iprw-1)
+         ELSE IF ( bc_dirichlet_r )  THEN
+            workarr_sn(0:pg%nz+1,0:2,iplw+1:iprw) = parent_array(0:pg%nz+1,jpbeg:jpbeg+2,iplw+1:iprw)
          ELSE
-            workarrc_sn(0:cg%nz+1,0:2,iclw+1:icrw-1)                            &
-                 = fc(0:cg%nz+1,mbeg:mbeg+2,iclw+1:icrw-1)
+            workarr_sn(0:pg%nz+1,0:2,iplw+1:iprw-1)                                                 &
+                 = parent_array(0:pg%nz+1,jpbeg:jpbeg+2,iplw+1:iprw-1)
          ENDIF
 !
@@ -4007,30 +4047,26 @@
 !--      the nest domain is not cyclic.
 !--      From left to right
-         CALL MPI_SENDRECV( workarrc_sn(0,0,iclw+1), 1,                         &
-              workarrc_sn_exchange_type, pleft,   0,                            &
-              workarrc_sn(0,0,icrw), 1,                                         &
-              workarrc_sn_exchange_type, pright,  0,                            &
-              comm2d, status, ierr ) 
-!
-!--      From right to left        
-         CALL MPI_SENDRECV( workarrc_sn(0,0,icrw-1), 1,                         &
-              workarrc_sn_exchange_type, pright,  1,                            &
-              workarrc_sn(0,0,iclw), 1,                                         &
-              workarrc_sn_exchange_type, pleft,   1,                            &
-              comm2d, status, ierr )
-#endif      
-      ELSE
-         workarrc_sn(0:cg%nz+1,0:2,iclw+1:icrw-1)                               &
-              = fc(0:cg%nz+1,mbeg:mbeg+2,iclw+1:icrw-1)
+         CALL MPI_SENDRECV( workarr_sn(0,0,iplw+1), 1, workarr_sn_exchange_type, pleft,   0,        &
+                            workarr_sn(0,0,iprw), 1, workarr_sn_exchange_type, pright, 0, comm2d,   &
+                            status, ierr )
+!                                                                           
+!--      From right to left                                                 
+         CALL MPI_SENDRECV( workarr_sn(0,0,iprw-1), 1, workarr_sn_exchange_type, pright,  1,        &
+                            workarr_sn(0,0,iplw), 1, workarr_sn_exchange_type, pleft, 1, comm2d,    &
+                            status, ierr )
+#endif                                                                      
+      ELSE                                                                  
+         workarr_sn(0:pg%nz+1,0:2,iplw+1:iprw-1)                                                    &
+              = parent_array(0:pg%nz+1,jpbeg:jpbeg+2,iplw+1:iprw-1)
       ENDIF
 
-      IF  ( var == 'v' )  THEN
-
-         DO  l = iclw, icrw
-            DO n = 0, kct 
+      IF ( var == 'v' )  THEN
+
+         DO  ip = iplw, iprw
+            DO  kp = 0, kct 
                
-               DO  i = ifl(l), ifu(l)
-                  DO  k = kfl(n), kfu(n)
-                     f(k,jbc,i) = workarrc_sn(n,mw,l)
+               DO  ic = ifl(ip), ifu(ip)
+                  DO  kc = kfl(kp), kfu(kp)
+                     child_array(kc,jcbc,ic) = workarr_sn(kp,jpw,ip)
                   ENDDO
                ENDDO
@@ -4039,21 +4075,21 @@
          ENDDO
 
-      ELSE IF  ( var == 'u' )  THEN
+      ELSE IF ( var == 'u' )  THEN
          
-         DO  l = iclw, icrw-1
-            DO n = 0, kct
+         DO  ip = iplw, iprw - 1
+            DO  kp = 0, kct
 !
 !--            First interpolate to the flux point
-               f_interp_1 = cb * workarrc_sn(n,mw,l)   + cp * workarrc_sn(n,mwp,l)
-               f_interp_2 = cb * workarrc_sn(n,mw,l+1) + cp * workarrc_sn(n,mwp,l+1)
+               c_interp_1 = cb * workarr_sn(kp,jpw,ip)   + cp * workarr_sn(kp,jpwp,ip)
+               c_interp_2 = cb * workarr_sn(kp,jpw,ip+1) + cp * workarr_sn(kp,jpwp,ip+1)
 !
 !--            Use averages of the neighbouring matching grid-line values
-               DO  i = ifl(l), ifl(l+1)
-                  f(kfl(n):kfu(n),jbc,i) = 0.5_wp * ( f_interp_1 + f_interp_2 )
+               DO  ic = ifl(ip), ifl(ip+1)
+                  child_array(kfl(kp):kfu(kp),jcbc,ic) = 0.5_wp * ( c_interp_1 + c_interp_2 )
                ENDDO
 !
 !--            Then set the values along the matching grid-lines  
-               IF  ( MOD( ifl(l), igsr ) == 0 )  THEN
-                  f(kfl(n):kfu(n),jbc,ifl(l)) = f_interp_1
+               IF ( MOD( ifl(ip), igsr ) == 0 )  THEN
+                  child_array(kfl(kp):kfu(kp),jcbc,ifl(ip)) = c_interp_1
                ENDIF
 
@@ -4062,8 +4098,8 @@
 !
 !--      Finally, set the values along the last matching grid-line  
-         IF  ( MOD( ifl(icrw), igsr ) == 0 )  THEN
-            DO  n = 0, kct
-               f_interp_1 = cb * workarrc_sn(n,mw,icrw) + cp * workarrc_sn(n,mwp,icrw)
-               f(kfl(n):kfu(n),jbc,ifl(icrw)) = f_interp_1
+         IF ( MOD( ifl(iprw), igsr ) == 0 )  THEN
+            DO  kp = 0, kct
+               c_interp_1 = cb * workarr_sn(kp,jpw,iprw) + cp * workarr_sn(kp,jpwp,iprw)
+               child_array(kfl(kp):kfu(kp),jcbc,ifl(iprw)) = c_interp_1
             ENDDO
          ENDIF
@@ -4073,33 +4109,34 @@
 !--      gap. Note however, this operation may produce some additional 
 !--      momentum conservation error.
-         IF  ( ifl(icrw) < nxr )  THEN
-            DO  n = 0, kct
-               DO  i = ifl(icrw)+1, nxr
-                  f(kfl(n):kfu(n),jbc,i) = f(kfl(n):kfu(n),jbc,ifl(icrw))
+         IF ( ifl(iprw) < nxr )  THEN
+            DO  kp = 0, kct
+               DO  ic = ifl(iprw) + 1, nxr
+                  child_array(kfl(kp):kfu(kp),jcbc,ic) = child_array(kfl(kp):kfu(kp),jcbc,ifl(iprw))
                ENDDO
             ENDDO
          ENDIF
 
-      ELSE IF  ( var == 'w' )  THEN
-
-         DO  l = iclw, icrw
-            DO n = 0, kct + 1   ! It is important to go up to kct+1  
+      ELSE IF ( var == 'w' )  THEN
+
+         DO  ip = iplw, iprw
+            DO  kp = 0, kct + 1   ! It is important to go up to kct+1  
 !
 !--            Interpolate to the flux point
-               f_interp_1 = cb * workarrc_sn(n,mw,l) + cp * workarrc_sn(n,mwp,l)
-!                  
-!--            First substitute only the matching-node values                 
-               f(kfu(n),jbc,ifl(l):ifu(l)) = f_interp_1
+               c_interp_1 = cb * workarr_sn(kp,jpw,ip) + cp * workarr_sn(kp,jpwp,ip)
+!
+!--            First substitute only the matching-node values
+               child_array(kfu(kp),jcbc,ifl(ip):ifu(ip)) = c_interp_1
 
             ENDDO
          ENDDO
 
-         DO  l = iclw, icrw
-            DO n = 1, kct + 1   ! It is important to go up to kct+1  
+         DO  ip = iplw, iprw
+            DO  kp = 1, kct + 1   ! It is important to go up to kct + 1  
 !
 !--            Then fill up the nodes in between with the averages
-               DO  k = kfu(n-1)+1, kfu(n)-1 
-                  f(k,jbc,ifl(l):ifu(l)) = 0.5_wp * ( f(kfu(n-1),jbc,ifl(l):ifu(l)) &
-                       + f(kfu(n),jbc,ifl(l):ifu(l)) )
+               DO  kc = kfu(kp-1) + 1, kfu(kp) - 1 
+                  child_array(kc,jcbc,ifl(ip):ifu(ip)) =                                            &
+                       0.5_wp * ( child_array(kfu(kp-1),jcbc,ifl(ip):ifu(ip))                       &
+                       + child_array(kfu(kp),jcbc,ifl(ip):ifu(ip)) )
                ENDDO
 
@@ -4109,12 +4146,12 @@
       ELSE   ! Any scalar
          
-         DO  l = iclw, icrw
-            DO n = 0, kct 
+         DO  ip = iplw, iprw
+            DO  kp = 0, kct 
 !
 !--            Interpolate to the flux point
-               f_interp_1 = cb * workarrc_sn(n,mw,l) + cp * workarrc_sn(n,mwp,l)
-               DO  i = ifl(l), ifu(l)
-                  DO  k = kfl(n), kfu(n)
-                     f(k,jbc,i) = f_interp_1
+               c_interp_1 = cb * workarr_sn(kp,jpw,ip) + cp * workarr_sn(kp,jpwp,ip)
+               DO  ic = ifl(ip), ifu(ip)
+                  DO  kc = kfl(kp), kfu(kp)
+                     child_array(kc,jcbc,ic) = c_interp_1
                   ENDDO
                ENDDO
@@ -4127,10 +4164,10 @@
 !--   Fill up also the redundant 2nd and 3rd ghost-node layers
       IF ( edge == 's' )  THEN
-         DO  jbgp = -nbgp, jb
-            f(0:nzt+1,jbgp,nxlg:nxrg) = f(0:nzt+1,jbc,nxlg:nxrg)
+         DO  jcbgp = -nbgp, jcb
+            child_array(0:nzt+1,jcbgp,nxlg:nxrg) = child_array(0:nzt+1,jcbc,nxlg:nxrg)
          ENDDO
       ELSEIF ( edge == 'n' )  THEN
-         DO  jbgp = jb, ny+nbgp
-            f(0:nzt+1,jbgp,nxlg:nxrg) = f(0:nzt+1,jbc,nxlg:nxrg)
+         DO  jcbgp = jcb, ny+nbgp
+            child_array(0:nzt+1,jcbgp,nxlg:nxrg) = child_array(0:nzt+1,jcbc,nxlg:nxrg)
          ENDDO
       ENDIF
@@ -4140,5 +4177,5 @@
 
 
-   SUBROUTINE pmci_interp_1sto_t( f, fc, kct, ifl, ifu, jfl, jfu, var )
+   SUBROUTINE pmci_interp_1sto_t( child_array, parent_array, kct, ifl, ifu, jfl, jfu, var )
 !
 !--   Interpolation of ghost-node values used as the child-domain boundary
